--- linux-2.6.9.orig/drivers/scsi/constants.c	2004-10-18 23:54:39.000000000 +0200
+++ linux-2.6.9/drivers/scsi/constants.c	2006-01-23 22:40:55.000000000 +0100
@@ -1006,7 +1006,9 @@
 		s = 4;
 	}
     
-#if !(CONSTANTS & CONST_SENSE)
+/* Enable raw sense byte printing.
+ * Originally by Fabien Collin. */
+#if (CONSTANTS & CONST_SENSE)
 	{
 		int i;
 	printk("Raw sense data:");
@@ -1017,13 +1019,23 @@
 #endif
 }
 
+/* NOTE(fuji): forward proto */
+void scsi_print_command(struct scsi_cmnd *cmd);
 void scsi_print_sense(const char *devclass, struct scsi_cmnd *cmd)
 {
+	scsi_print_command(cmd);
 	print_sense_internal(devclass, cmd->sense_buffer, cmd->request);
 }
 
 void scsi_print_req_sense(const char *devclass, struct scsi_request *sreq)
 {
+	if (sreq->sr_command) {
+		/* FIXME(fuji): We have seen cases where sr_command was
+		 * NULL, e.g. USB floppy, not sure if it is legal or not,
+		 * but since scsi_print_command() has no guards againts null
+		 * cmd we have to prevent an oops here. */
+		scsi_print_command(sreq->sr_command);
+	}
 	print_sense_internal(devclass, sreq->sr_sense_buffer, sreq->sr_request);
 }
 
